bool blueLEDStatus = false;
void blueLED(bool onoff) {
  if (onoff) {
    blueLEDStatus = true;
    digitalWrite(4, 1);
  } else {
    blueLEDStatus = false;
    digitalWrite(4, 0);
  }
}

void blueLEDblink() {
  blueLED(!blueLEDStatus);
}

float blinking = 0;
void startBlink(float timeSec) {
  if (timeSec != blinking) {
    blinker.attach(timeSec,blueLEDblink);
    blinking = timeSec;
  }
}

long countBlinkCounter=0;
void stopBlink() {
  if (countBlinkCounter<=0) {
    blinker.detach();
    blinking = 0;
    blueLED(false);
  }
}

void startCountBlink(float timeSec,long count) {
  blueLED(false);
  delay(10);
  countBlinkCounter=count;
  blinker.attach(timeSec,countBlink);
  blinking = timeSec;
}

void countBlink() {
  if (countBlinkCounter<=0) {
    stopBlink();
  } else {
    blueLEDblink();
  }
  countBlinkCounter--;
}