//wh
void handle_update()
{
  String rTime = "";
  if (enableReconnect == 1)
  {
    rTime = NTP.getTimeStr((timeNow - LastKeepWIFIAlive) / 1000) + "/";
  }
  String delayTimer = "OFF";
  if (enableDelay == true)
  {
    if (timeNow < iDelayON && handle_Delay == 1)
    {
      delayTimer = "DelayON:" + NTP.getTimeStr((iDelayON - timeNow) / 1000);
    }
    if (timeNow < iDelayOFF && handle_Delay == 2)
    {
      delayTimer = "DelayOFF:" + NTP.getTimeStr((iDelayOFF - timeNow) / 1000);
    }
    if (timeNow < iONDelayOFF && handle_Delay == 3)
    {
      delayTimer = "ONDelayOFF:" + NTP.getTimeStr((iONDelayOFF - timeNow) / 1000);
    }
    if (timeNow < iOFFDelayON && handle_Delay == 4)
    {
      delayTimer = "OFFDelayON:" + NTP.getTimeStr((iOFFDelayON - timeNow) / 1000);
    }
    if (timeNow < iAutoONOFF && handle_Delay == 5)
    {
      delayTimer = "AutoONFF:" + NTP.getTimeStr((iAutoONOFF - timeNow) / 1000);
    }
    if (timeNow < iDelayWatchDogOn && handle_Delay == 10)
    {
      delayTimer = "Watch Dog Reset in:" + NTP.getTimeStr((iDelayWatchDogOn - timeNow) / 1000);
    }
    if (timeNow < iDelayWatchDogOff && handle_Delay == 11)
    {
      delayTimer = "Watch Dog Power on in:" + NTP.getTimeStr((iDelayWatchDogOff - timeNow) / 1000);
    }
  }
  String dTmp = "";
  if (getDelayStatus().length() > 0)
  {
    dTmp = "/" + getDelayStatus();
  }
  String updateValue = String(timeStamp()) + ";" + relStatus + ";" + wwwStatus1 + ";" + dTmp + ";" + rTime + ";" + delayTimer + ";" + WiFi.RSSI() + ";" + gerDate(NTP.getTimeDateString()) + ";" + NTP.getNtpServerName() + ";" + String(iDevname) + ";" + fIPown.toString() + ";" + fIPsubnet.toString() + ";" + fIPgateway.toString() + ";" + fIPstatus + ";" + wwwStatus2 + ";" + ESP.getFreeHeap() + ";" + String(system_get_cpu_freq()) + ";";

  server.send(200, F("text/plane"), updateValue);
  delay(100);
}

void handle_getState()
{
  String updateValue = relStatus;
  server.send(200, F("text/plane"), updateValue);
}
//wh
//switch Relay ON

void handle_toggle()
{
  if (relStatus == "OFF")
  {
    switch_ON();
  }
  if (relStatus == "ON")
  {
    switch_OFF();
  }
}

void setRelay(int state)
{
  if (state == 1)
  { // on
    digitalWrite(12, 0);
    delay(50);
    digitalWrite(12, 1);
    reportIOB(1);
    reportCCU("1");
    reportMQTT(1);
  }
  else
  { //off
    digitalWrite(5, 0);
    delay(50);
    digitalWrite(5, 1);
    reportIOB(0);
    reportCCU("0");
    reportMQTT(0);
  }
  if (stateONPowerON == 2)
  {
    writeState(state);
  }
}

void switch_ON_intern()
{
  //first we gonna cancel all running delay functions
  enableDelay = false;
  setDelayStatus("");
  // we do need to create a low pulse on GPIO12
  setRelay(1);
  // digitalWrite(4, 1);
  blueLED(true);
  relStatus = "ON";
  Serial.println(F("Relay ON"));
  build_wwwStatus1(F("RELAY ON"));
}

void switch_ON()
{
  switch_ON_intern();
  String eAnswer = server.arg("ON");
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Switched permantly ON " + wwwGoBack);
  delay(100);
}

void switch_OFF_intern()
{
  //first we gonna cancel all running delay functions
  enableDelay = false;
  setDelayStatus("");
  // we do need to create a low pulse on GPIO5
  setRelay(0);
  // digitalWrite(4, 0);
  blueLED(false);
  relStatus = "OFF";
  Serial.println(F("Relay OFF"));
  build_wwwStatus1("RELAY OFF");
}
//switch Relay OFF
void switch_OFF()
{
  switch_OFF_intern();
  String eAnswer = server.arg("OFF");
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Switched permanently OFF " + wwwGoBack);
  delay(100);
}

//switch Relay ON for delayed operations
void delayswitch_ON()
{
  // we do need to create a low pulse on GPIO12
  setRelay(1);
  // digitalWrite(4, 1);
  blueLED(true);
  relStatus = "ON";
  Serial.println(F("delay Relay ON"));
  build_wwwStatus1(F("RELAY ON"));
}

//switch Relay OFF for delayed operations
void delayswitch_OFF()
{
  // we do need to create a low pulse on GPIO5
  setRelay(0);
  // digitalWrite(4, 0);
  blueLED(false);
  relStatus = "OFF";
  Serial.println(F("delay Relay OFF"));
  build_wwwStatus1(F("RELAY OFF"));
}

void handle_watchDog()
{
  setDelayStatus("WatchDogOn");
  handle_Delay = 10;
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "WatchDog aktiviert" + wwwGoBack);
  delay(100);
  build_wwwStatus2(F("WatchDogRestart"));
  enableDelay = true;
  if (relStatus == "OFF")
  {
    delayswitch_ON();
  }
  if (stateONPowerON == 0)
  {
    stateONPowerON = 1;
    delay_PowerONState();
  }
  iDelayWatchDogOn = HardwareDogOnTime + millis();
  iDelayWatchDogOff = HardwareDogOnTime + HardwareDogOffTime + millis();
}

void delay_ON()
{
  setDelayStatus("delay ON");
  handle_Delay = 1;
  String eD = server.arg("");
  if (eD != "")
  {
    iDelayON = eD.toInt();
    if (iDelayON < 1)
    {
      iDelayON = 1;
    }
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Delay ON : " + String(eD) + wwwGoBack);
    delay(100);
    build_wwwStatus1(F("DELAY ON"));
    enableDelay = true;
    iDelayON = iDelayON * 1000 + millis();
  }
}

void delay_OFF()
{
  setDelayStatus("delay OFF");
  handle_Delay = 2;
  String eD = server.arg("");
  if (eD != "")
  {
    iDelayOFF = eD.toInt();
    if (iDelayOFF < 1)
    {
      iDelayOFF = 1;
    }
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Delay OFF : " + String(eD) + wwwGoBack);
    delay(100);
    build_wwwStatus1(F("DELAY OFF"));
    enableDelay = true;
    iDelayOFF = iDelayOFF * 1000 + millis();
  }
}

void ON_delay_OFF()
{
  setDelayStatus("ON delay OFF");
  handle_Delay = 3;
  String eD = server.arg("");
  if (eD != "")
  {
    iONDelayOFF = eD.toInt();
    if (iONDelayOFF < 1)
    {
      iONDelayOFF = 1;
    }
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Delay OFF : " + String(eD) + wwwGoBack);
    delay(100);
    build_wwwStatus1(F("ON_DELAY OFF"));
    enableDelay = true;
    iONDelayOFF = iONDelayOFF * 1000 + millis();
    delayswitch_ON();
  }
}

void OFF_delay_ON()
{
  setDelayStatus(" OFF delay ON");
  handle_Delay = 4;
  String eD = server.arg("");
  if (eD != "")
  {
    iOFFDelayON = eD.toInt();
    if (iOFFDelayON < 1)
    {
      iOFFDelayON = 1;
    }
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Delay OFF : " + String(eD) + wwwGoBack);
    delay(100);
    build_wwwStatus1(F("OF_DELAY ON"));
    enableDelay = true;
    iOFFDelayON = iOFFDelayON * 1000 + millis();
    delayswitch_OFF();
  }
}

void AUTO_ON_OFF()
{
  setDelayStatus("Auto ON/OFF");
  handle_Delay = 5;
  String eD = server.arg("");
  if (eD != "")
  {
    iAutoONOFF = eD.toInt();
    if (iAutoONOFF < 1)
    {
      iAutoONOFF = 1;
    }
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Auto ON-OFF : " + String(eD) + wwwGoBack);
    delay(100);
    build_wwwStatus1(F("Auto ON-OFF"));
    enableDelay = true;
    dAutoONOFF = iAutoONOFF * 1000;
    iAutoONOFF = iAutoONOFF * 1000 + millis();
    delayswitch_ON();
  }
}

// Send a command to another server when Relay switches ON
//this is a future function
void command_ON() {}

// Send a command to another server when Relay switches OFF
// this is a future function
void command_OFF() {}

// Relay State on PowerON
// Prepare to be written to EEPROM
// stateONPowerON
void handle_PowerONState()
{
  String ePO = server.arg("");

  if (ePO != "")
  {
    eeprom_Function = 7;
    stateONPowerON = ePO.toInt();
    if (stateONPowerON > 2 || stateONPowerON < 0)
    {
      stateONPowerON = 0;
    }
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "PowerOnState : " + String(ePO) + wwwGoBack);
    delay(100);
    //Serial.println("PowerOnState");
    if (stateONPowerON == 2)
    {
      writeState((relStatus == "ON") ? 1 : 0);
    }
    writeEEPROM();
  }
}

void delay_PowerONState()
{
  eeprom_Function = 7;
  if (stateONPowerON > 2 || stateONPowerON < 0)
  {
    stateONPowerON = 0;
  }
  delay(100);
  if (stateONPowerON == 2)
  {
    writeState((relStatus == "ON") ? 1 : 0);
  }
  //Serial.println("delay PowerOnState");
  writeEEPROM();
}

// Set wifi.Reconnect function ON / OFF
void handle_Reconnect()
{
  String eReconnect = server.arg("");

  if (eReconnect != "")
  {
    eeprom_Function = 9;
    enableReconnect = eReconnect.toInt();
    if (enableReconnect > 1 || enableReconnect < 0)
    {
      enableReconnect = 1;
    }
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Wifi.Reconnect enabled : " + String(eReconnect) + wwwGoBack);
    delay(100);
    //Serial.println("Reconnect");
    writeEEPROM();
  }
}

void handle_KeepAlive()
{
  eeprom_Function = 30;
  String eKeepAlive = server.arg("");
  DeltaKeepWIFIAlive = eKeepAlive.toInt() * 1000;
  if (DeltaKeepWIFIAlive < 60000)
  {
    DeltaKeepWIFIAlive = 60000;
  }
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Wifi.Reconnect Time : " + String(DeltaKeepWIFIAlive / 1000) + " sec." + wwwGoBack);
  IOB_Message = timeStamp() + "Iam Alive";

  delay(100);
  writeEEPROM();
}

void handle_watchDogOnTime()
{
  eeprom_Function = 31;
  String tmp = server.arg("");
  HardwareDogOnTime = tmp.toInt() * 1000;
  if (HardwareDogOnTime < 60000)
  {
    HardwareDogOnTime = 60000;
  }
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "HardwareDogOnTime : " + String(HardwareDogOnTime / 1000) + " sec." + wwwGoBack);

  delay(100);
  writeEEPROM();
}

void handle_watchDogOffTime()
{
  eeprom_Function = 32;
  String tmp = server.arg("");
  HardwareDogOffTime = tmp.toInt() * 1000;
  if (HardwareDogOffTime < 10000)
  {
    HardwareDogOffTime = 10000;
  }
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "HardwareDogOffTime : " + String(HardwareDogOffTime / 1000) + " sec." + wwwGoBack);

  delay(100);
  writeEEPROM();
}

void handle_ntpServer()
{
  eeprom_Function = 33;
  String tmp = server.arg("");
  int tmpVal = tmp.toInt();
  String ntpServ = "pool.ntp.org";
  if (tmpVal == 1)
  {
    ntpServ = WiFi.gatewayIP().toString();
  }
  iNTPServer = tmpVal;
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "NtpServer : " + ntpServ + " " + wwwGoBack);
  NTP.setNtpServerName(ntpServ);
  delay(100);
  writeEEPROM();
}

void handle_devName()
{
  eeprom_Function = 34;
  String tmp = server.arg("");
  iDevname = tmp;
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Name : " + iDevname + " " + wwwGoBack);
  delay(100);
  char tmpc[32];
  tmp.toCharArray(tmpc, 32);
  MDNS.begin(tmpc);
  writeEEPROM();
}

void handle_IPown()
{
  eeprom_Function = 36;
  String tmp = server.arg("");
  fIPown.fromString(tmp);
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "IP : " + fIPown.toString() + " " + wwwGoBack);
  delay(100);
  writeEEPROM();
  if (fIPstatus == 1)
  {
    WiFi.config(fIPown, fIPgateway, fIPsubnet);
  }
}

void handle_IPgateway()
{
  eeprom_Function = 37;
  String tmp = server.arg("");
  fIPgateway.fromString(tmp);
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Gateway : " + fIPgateway.toString() + " " + wwwGoBack);
  delay(100);
  writeEEPROM();
  if (fIPstatus == 1)
  {
    WiFi.config(fIPown, fIPgateway, fIPsubnet);
  }
}

void handle_IPsubnet()
{
  eeprom_Function = 38;
  String tmp = server.arg("");
  fIPsubnet.fromString(tmp);
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Gateway : " + fIPsubnet.toString() + " " + wwwGoBack);
  delay(100);
  writeEEPROM();
  if (fIPstatus == 1)
  {
    WiFi.config(fIPown, fIPgateway, fIPsubnet);
  }
}

void handle_IPstatus()
{
  eeprom_Function = 39;
  String tmp = server.arg("");
  fIPstatus = tmp.toInt();
  if (fIPstatus < 0 || fIPstatus > 1)
  {
    fIPstatus = 0;
  }
  delay(100);
  writeEEPROM();
  if (fIPstatus == 1)
  {
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "FIX-IP-Status : " + fIPstatus + " " + wwwGoBack);
    WiFi.config(fIPown, fIPgateway, fIPsubnet);
  }
  else
  {
    server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "FIX-IP-Status : " + fIPstatus + " please reboot device" + wwwGoBack);
  }
}

void handle_cpufreq()
{
  eeprom_Function = 40;
  String tmp = server.arg("");
  fcpufreq = tmp.toInt();
  if ((fcpufreq != 80) && (fcpufreq != 160))
  {
    fcpufreq = 80;
  }
  system_update_cpu_freq(fcpufreq);
  delay(100);
  writeEEPROM();
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "CPU-Freq : " + String(fcpufreq) + " " + wwwGoBack);
}

void handle_ajax()
{
  eeprom_Function = 41;
  String tmp = server.arg("");
  ajaxon = tmp.toInt();
  if ((ajaxon < 0) || (ajaxon > 1))
  {
    ajaxon = 1;
  }
  delay(100);
  writeEEPROM();
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "AJAX : " + String(ajaxon) + " (0=OFF/1=ON) " + wwwGoBack);
}

void handle_ping()
{
  eeprom_Function = 42;
  String tmp = server.arg("");
  pingTest = tmp.toInt();
  if ((pingTest < 0) || (pingTest > 1))
  {
    pingTest = 1;
  }
  delay(100);
  writeEEPROM();
  server.send(200, F("text/html; charset=utf-8"), wwwCommandHeader + "Ping : " + String(pingTest) + " (0=OFF/1=ON) " + wwwGoBack);
}
